/* Script for NetRexx on OS/2 with Java */

/* Load RexxUtil Library */
IF RxFuncQuery( 'SysLoadFuncs' ) THEN
DO
    CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
    CALL SysLoadFuncs
END

env = 'ENVIRONMENT'
PARSE SOURCE system . this
PARSE ARG args

IF system = 'OS/2' THEN
DO
   PARSE VALUE REVERSE( this ) WITH .'\'here
   here = REVERSE( here )
   PARSE VALUE here WITH here'\BIN'
   CALL SysGetEA this, 'NRX_PATH', nrx_path
   CALL SysGetEA this, 'J_PATH', j_path
   IF here = nrx_path THEN
      IF j_path <> '' THEN
         here = j_path
            
   PARSE UPPER VALUE rxFind( 'JAVA.EXE', '-version', 'VERSION "1.', here||'\BIN' ) WITH j_path'\BIN'type' VERSION "1.'minor'.'rev'_'build'"'
   type = TRANSLATE( type, 'pen', 'PEN' )
   CALL VALUE 'J_PATH', j_path, env
   CALL wpsAdd type||' '||minor||'.'||rev, 'OBJECTID=<RUN_'||SPACE( TRANSLATE( type||minor||rev||build,, '.' ), 0 )||'>;EXENAME='||j_path||'\bin\'||FILESPEC( 'N', this )||';PARAMETERS="%**P\%**F";PROGTYPE=PROG_WINDOWABLEVIO;STARTUPDIR='||j_path||';ASSOCFILTER=*.jar,*.class;ICONFILE='||j_path||'\bin\'||type||'.ico;'
   IF STREAM( nrx_path||'\LIB\NetRexxC.jar', 'C', 'QUERY EXISTS' ) = '' & nrx_path <> 'NULL' THEN
      PARSE UPPER VALUE rxFind( 'NetRexxC.jar',,, nrx_path||'\LIB', 3 ) WITH nrx_path'\BIN'
   IF nrx_path = '' THEN nrx_path = 'NULL' /* NetRexx not found, disable it */
   CALL SysPutEA this, 'NRX_PATH', nrx_path
   CALL SysPutEA this, 'J_PATH', j_path
   IF nrx_path <> 'NULL' THEN
      CALL wpsAdd 'NetRexx Compiler / Run', 'OBJECTID=<NRXC>;EXENAME='||nrx_path||'\bin\'||FILESPEC( 'N', this )||';PARAMETERS=org.netrexx.process.NetRexxC [Type "-run" (without quotes) to just run the compiled script] %**P\%**F;STARTUPDIR='||nrx_path||';PROGTYPE=PROG_WINDOWABLEVIO;ASSOCFILTER=*.nrx;ICONFILE='||nrx_path||'\NetRexxKing.ico;'
   PARSE VALUE args WITH '"'app'"'
   PARSE VALUE REVERSE( app ) WITH ext'.'cls'\'app_path
   cls = REVERSE( cls )
   ext = REVERSE( ext )
   PARSE UPPER VALUE cls WITH objid'-'
   PARSE VALUE objid WITH objid'_'
   PARSE VALUE REVERSE( app_path ) WITH app_path'\lib'
   PARSE VALUE app_path WITH app_path'\bin'
   PARSE VALUE app WITH (app_path)run
   IF 0 < LENGTH( cls ) THEN
   DO
      IF 0 < POS( TRANSLATE( cls )||'.JAR', TRANSLATE( args ) ) THEN
         CALL wpsAdd cls, 'OBJECTID=<JAV_'||objid||'>;EXENAME='||this||';PARAMETERS=-jar "'||STRIP( run, 'L', '\' )||'";STARTUPDIR='||app_path||';PROGTYPE=PROG_WINDOWABLEVIO;MINIMIZED=YES;ICONFILE='||app_path||'\'||cls||'.ico;'
      ELSE IF 0 < POS( TRANSLATE( cls )||'.CLASS', TRANSLATE( args ) ) THEN
      DO
         PARSE VALUE REVERSE( run ) WITH '.'run
         CALL wpsAdd cls, 'OBJECTID=<CLA_'||objid||'>;EXENAME='||this||';PARAMETERS="'||STRIP( REVERSE( run ), 'L', '\' )||'";STARTUPDIR='||app_path||';PROGTYPE=PROG_WINDOWABLEVIO;MINIMIZED=YES;ICONFILE='||app_path||'\'||cls||'.ico;'
         PARSE VALUE args WITH pre(app_path)'\'.'.class'post
         args = STRIP( SPACE( pre cls post ),, '"' )
      END
   END
END
IF ARG() = 0 THEN
DO
   CALL LINEOUT 'STDERR', 'Usage: '
   CALL LINEOUT 'STDERR', '       '||FILESPEC( 'N', this )||' file.ext'
   RETURN 1
END
ELSE IF system = 'OS/2' THEN
DO
   params = 'RUN NOCOMPILE'
   ds = '- /'
   DO i = 1 TO WORDS( params )
      DO j = 1 TO WORDS( ds )
         CALL VALUE LEFT( SUBWORD( params, i, 1 ), 3 ), WORDPOS( SUBWORD( ds, j, 1 )||SUBWORD( params, i, 1 ), TRANSLATE( args ) )
         IF 0 < VALUE( LEFT( SUBWORD( params, i, 1 ), 3 ) ) THEN ITERATE i
      END
   END
   
   IF TRANSLATE( here ) = TRANSLATE( nrx_path ) THEN
      IF 0 = POS( nrx_path||'\LIB', TRANSLATE( VALUE( 'PATH',, env ) ) ) THEN
         CALL VALUE 'PATH', nrx_path||'\lib;'||VALUE( 'PATH',, env ), env
   IF 0 = POS( TRANSLATE( j_path )||'\BIN', TRANSLATE( VALUE( 'PATH',, env ) ) ) THEN
      CALL VALUE 'PATH', '.;'||j_path||'\bin;'||j_path||'\lib;'||VALUE( 'PATH',, env ), env
   
   javaopts = ''
   IF 0 < run THEN args = DELWORD( args, run, 1 )
   PARSE VALUE TRANSLATE( STRIP( RxChk( j_path||'\BIN\JAVA.EXE', '-version', 'VERSION "1.' ) ) ) WITH 'VERSION "1.'minor'"'
   PARSE VALUE minor WITH minor'_'build

   IF minor >= 6.0 THEN
   DO
      IF TRANSLATE( here ) = TRANSLATE( nrx_path ) THEN
         CALL VALUE 'CLASSPATH', '.;'||nrx_path||'\lib\NetRexxC.jar;'||j_path||'\lib\tools.jar', env
      ELSE IF 0 < LENGTH( VALUE( 'CLASSPATH',, env ) ) THEN
         CALL VALUE 'CLASSPATH', '.;'||app_path||';'||VALUE( 'CLASSPATH',, env )||';'||j_path||'\lib\tools.jar', env
      ELSE
         CALL VALUE 'CLASSPATH', '.;'||app_path||';'||j_path||'\lib\tools.jar', env
   END
   ELSE IF minor >= 4.1 THEN
      CALL VALUE 'CLASSPATH', '.;'||VALUE( 'CLASSPATH',, env )||';'||j_path||'\lib\tools.jar', env
   ELSE IF minor >= .2 THEN
      javaopts='-norestart'
   ELSE IF minor <> '' THEN
      javaopts='-noasyncgc'
   
   CALL VALUE 'SWING_HOME', j_path||'\bin'
   
   /* Add any options from NETREXX_JAVA environment variable */
   IF TRANSLATE( here ) = TRANSLATE( nrx_path ) THEN
   DO
      nrjava = VALUE( 'NETREXX_JAVA',, env )
      IF nrjava <> '' THEN
         javaopts = javaopts nrjava
   END
END
ELSE /* Add any options from NETREXX_JAVA environment variable */
   javaopts = VALUE( 'NETREXX_JAVA',, env )
old_trace = TRACE( 'O' )
IF VALUE( 'DEBUG',, env ) = 1 THEN
'@java '||SPACE( javaopts args )||' >debug.log'
ELSE IF VALUE( 'DEBUG',, env ) = 2 THEN
   '@java '||SPACE( javaopts args )||' 2>debug.log'
ELSE IF VALUE( 'DEBUG',, env ) = 3 THEN
   '@java '||SPACE( javaopts args )||' 2>&1 >debug.log'
ELSE
   '@java '||SPACE( javaopts args )
CALL TRACE old_trace

IF rc <= 1 & 0 < run THEN
DO
   IF 0 < noc THEN
      CALL LINEOUT 'STDERR', 'Run option ignored as -nocompile specified'
   ELSE /* OS/2-specific section of code */
   DO FOREVER
      PARSE VAR args file args
      IF file = '' THEN LEAVE
      IF 0 < WORDPOS( LEFT( file, 1 ), ds ) THEN ITERATE
      filename = FILESPEC( 'N', file )
      PARSE VAR filename fn '.' fe
      /* Now determine the exact case of the class, for java commands */
      CALL SysFileTree fn||'.class', 'foo.', 'FO'
      IF foo.0 <> 1 THEN
      DO
         IF foo.0 = 0 THEN
            CALL LINEOUT 'STDERR', 'Cannot find file: '||file
         ELSE IF foo.0 > 1 THEN
            CALL LINEOUT 'STDERR', 'File "'||file||'" is not a unique specification'
         EXIT 1
      END
      PARSE VALUE FILESPEC( 'N', foo.1 ) WITH fn '.' fe /* is now correct case */
      CALL LINEOUT 'STDERR', 'Running '||fn||'...'
      '@java '||fn
   END
END
ELSE IF 0 < run THEN
   PARSE PULL
RETURN rc

wpsAdd: PROCEDURE EXPOSE this here env
   PARSE ARG objlbl, setupstring
   PARSE VALUE setupstring WITH 'OBJECTID=<'objid'>;'
   IF wpsObjectExist( '<'||objid||'>' ) = 0 THEN
   DO
      PARSE VALUE REVERSE( setupstring ) WITH ';oci.'objimg'\'app_path'=ELIFNOCI;'
      objimg = REVERSE( objimg )
      app_path = REVERSE( app_path )
      IF objlbl <> objimg THEN
      DO
         CALL SysCopyObject this, app_path
         CALL SysFileTree here||'\'||objimg||'*', 'files.', 'FO'
         DO i = 1 TO files.0
            CALL SysCopyObject files.i, app_path
         END
      END
      setupstring = adapt( objid, setupstring )
      CALL SysCreateObject 'WPProgram', objlbl, '<WP_DESKTOP>', setupstring, 'U'
      CALL rxAddBigIcon '<'||objid||'>', app_path||'\'||objimg||'.png'
      RETURN 1
   END
RETURN 0
   
adapt: PROCEDURE EXPOSE this env
   PARSE ARG ident, setupstring
   PARSE VALUE setupstring WITH 'PARAMETERS'.'"'app'"'. ';'
   IF 0 < POS( '<CLA_', setupstring ) THEN
   DO
      cls = app
      PARSE VALUE setupstring WITH 'STARTUPDIR='app_path';'
      app = app_path||'\'||app||'.class'
   END
   ELSE DO
      PARSE VALUE REVERSE( app ) WITH '.'cls'\'app_path
      app_path = REVERSE( app_path )
      cls = REVERSE( cls )
   END
   f_size = CHARS( this )
   CALL STREAM this, 'C', 'OPEN READ'
   input = CHARIN( this, 1, f_size )
   CALL STREAM this, 'C', 'CLOSE'
   PARSE VALUE input WITH '/*<'(ident)'>'modify'*/'
   DO WHILE 0 < LENGTH( STRIP( modify ) )
      PARSE VALUE STRIP( modify ) WITH adjust';'modify
      PARSE VALUE adjust WITH part'='target
      PARSE VALUE setupstring WITH pre(part) . ';'post
      setupstring = pre||part||'='||target||';'||post
   END
   IF VALUE( 'USER_HOME',, env ) <> '' THEN
      setupstring = '-Duser.home=%app_path% '||setupstring
   setupstring = CHANGESTR( '%j_path%', CHANGESTR( '%unixroot%', CHANGESTR( '%home%', CHANGESTR( '%programs%', CHANGESTR( '%cls%', CHANGESTR( '%app%', CHANGESTR( '%app_path%', setupstring, app_path ), app ), cls ), VALUE( 'PROGRAMS',, env ) ), VALUE( 'HOME',, env ) ), VALUE( 'UNIXROOT',, env ) ), VALUE( 'J_PATH',, env ) )
   IF 0 < POS( '%delete%(', setupstring ) THEN
   DO
      PARSE VALUE setupstring WITH pre'%delete%('what','from')'rest
      setupstring = pre||CHANGESTR( STRIP( what ), STRIP( from ), '', 1 )||rest
   END
RETURN setupstring

RxChk: PROCEDURE
   org_trace = TRACE( 'O' )
   PARSE ARG cls, chk, ver, pth
   DO WHILE QUEUED() > 0; PARSE PULL; END;
   IF STREAM( cls, 'C', 'QUERY EXISTS' ) <> '' THEN
      '@'||SPACE( cls||' '||chk||' 2>>&1 | RXQUEUE' )
   CALL TRACE org_trace
   DO WHILE 0 < QUEUED()
      cmp = LINEIN( 'QUEUE:' )
      IF 0 < POS( TRANSLATE( ver ), TRANSLATE( cmp ) ) | ver = '' THEN
         IF 0 < LENGTH( pth ) THEN RETURN pth||''||cmp
         ELSE RETURN cmp
   END
RETURN ''

RxFind: PROCEDURE EXPOSE env
   PARSE ARG file, chk, ver, pth, limit
   IF limit = '' THEN limit = 10
   cmp = rxChk( pth||'\'||file, chk, ver, pth )
   IF cmp <> '' THEN RETURN cmp
   ELSE IF limit < 2 THEN RETURN ''
   CALL LINEOUT 'STDERR', 'Searching for "'||file||'". One moment please...'
   pth = SysSearchPath( 'PATH', file )
   PARSE VALUE REVERSE( pth ) WITH .'\'pth
   pth = STRIP( REVERSE( pth ) )
   cmp = rxChk( pth||'\'||file, chk, ver, pth )
   IF cmp <> '' THEN RETURN cmp
   ELSE IF limit < 3 THEN RETURN ''
   pth = VALUE( 'PROGRAMS',, env )
   CALL LINEOUT 'STDERR', 'Programs: '||pth
   CALL SysFileTree pth||'\*'||file, 'files.', 'SFO'
   DO i = 1 TO files.0
      PARSE VALUE REVERSE( files.i ) WITH .'\'pth
      pth = STRIP( REVERSE( pth ) )
      cmp = rxChk( files.i, chk, ver, pth )
      IF cmp <> '' THEN RETURN cmp
   END
   IF limit < 4 THEN RETURN ''
   drives = SysDriveMap( 'C:', 'LOCAL' )
   DO i = 1 TO WORDS( drives )
      pth = SUBWORD( drives, i, 1 )
      CALL LINEOUT 'STDERR', 'Drive: '||pth
      CALL SysFileTree pth||'\*'||file, 'files.', 'SFO'
      DO j = 1 TO files.0
         PARSE VALUE REVERSE( files.j ) WITH .'\'pth
         pth = REVERSE( pth )
         CALL LINEOUT 'STDERR', 'Folder: '||pth
         cmp = rxChk( files.i, chk, ver, pth )
         IF cmp <> '' THEN RETURN cmp
      END
   END
RETURN ''

RxGetMain: PROCEDURE EXPOSE j_path env
   PARSE ARG jarfile
   IF RIGHT( TRANSLATE( jarfile ), 4 ) = '.JAR' THEN
      RETURN SUBWORD( STRIP( RxChk( j_path||'\BIN\JAVA.EXE', 'MF '||jarfile||' Main-Class', 'Main-Class: ' ) ), 2 )
RETURN ''

RxAddBigIcon: PROCEDURE EXPOSE env
   PARSE ARG objid, objfile
   crlf = D2C(13)||D2C(10)
   big_dir = VALUE( 'BIGICONS',, env )
   IF big_dir <> '' & STREAM( objfile, 'C', 'QUERY EXIST' ) <> ''  THEN
   DO
      big_ini = big_dir||'\bigicons.txt'
      objimage = FILESPEC( 'N', objfile )
      CALL SysCopyObject objfile, big_dir
      IF STREAM( big_ini, 'C', 'QUERY EXIST' ) <> '' THEN
      DO
         f_size = STREAM( big_ini, 'C', 'QUERY SIZE' )
         IF 0 < f_size THEN
         DO
            input = CHARIN( big_ini, 1, f_size )
            CALL STREAM big_ini, 'C', 'CLOSE'
            PARSE VALUE input WITH pre'"'(objimage)'"'post
            IF 0 < LENGTH( post ) THEN RETURN 2
            PARSE VALUE input WITH pre'"'(objid)'"'post
            IF 0 < LENGTH( post ) THEN RETURN 3
            PARSE VALUE input WITH pre'[OBJECTID]'mid'['post
            DO 3
               DO i = 1 TO 4 BY 3
                  mid = STRIP( mid, 'T', D2C( 9 + i ) )
               END
            END
            input = pre'[OBJECTID]'||mid||crlf||LEFT( '"'||objid||'"', 28 )||'"'||objimage||'"'||COPIES( crlf, 2 )||'['||post
            CALL SysFileDelete big_ini
            CALL CHAROUT big_ini, input
            CALL STREAM big_ini, 'C', 'CLOSE'
         END
         ELSE RETURN 4
      END
   END
RETURN 0

/* Code borrowed from REXX Tips & Tricks v3.60 */
wpsObjectExist: PROCEDURE /* parameter: '<new_wps_object_id>', return: 1 exist, 0 doesn't exist, 43 error */
   PARSE ARG objID
   rc = 43               /* init return/error code 43 = routine not found */
   SIGNAL ON SYNTAX NAME ObjectExistError

   IF SUBSTR( objID, 2, 1 ) <> ":" THEN
      IF LEFT( objID, 1 ) <> "<" & RIGHT( objID, 1 ) <> ">" THEN
         objID = "<" || objID || ">"

/* create the object and see if it fail */
   rc = \SysCreateObject( "WPFolder", "TestObject", "<WP_NOWHERE>", "OBJECTID=" || objID || ";", "FAIL" )

   IF \rc THEN
      CALL SysDestroyObject objID

ObjectExistError:
RETURN rc
   
/* Replace one string (needle) with another (newneedle) in text (haystack) */
CHANGESTR: PROCEDURE /* needle, haystack <, newneedle<, caseless>> */
    IF TRACE() = '?I' THEN CALL TRACE 'O'
    PARSE ARG needle, haystack, newneedle, caselss
    new_haystack = ''
    IF caselss = '' THEN
    DO WHILE 0 < POS( needle, haystack )
        PARSE VALUE haystack WITH pre(needle)haystack
        new_haystack = new_haystack||pre||newneedle
    END
    ELSE DO
       needle = TRANSLATE( needle )
       strpos = POS( needle, TRANSLATE( haystack ) )
       DO WHILE 0 < strpos
          IF 1 < strpos THEN
             pre = LEFT( haystack, strpos - 1 )
          ELSE pre = ''
          haystack = SUBSTR( haystack, strpos + LENGTH( needle ) )
          new_haystack = new_haystack||pre||newneedle
          strpos = POS( needle, TRANSLATE( haystack ) )
       END
    END
RETURN new_haystack||haystack
   
/* The section below contain application specific configurations */
/*<JAV_JAVA2NRX> PARAMETERS=-Xmx512m -Xms32m -jar "%app%" %**P\%**F %**P\%**N.nrx;ASSOCFILTER=*.java*/
/*<JAV_RUN> PARAMETERS=-Xmx512m -Xms32m -jar "%app%"*/
/*<JAV_JDOWNLOADER> PARAMETERS=-Xmx512m -jar "%app%"*/
/*<JAV_SMARTGIT> PARAMETERS=-Xmx512m -Dsmartgit.checkIncompatibleJava=false -jar "%app%"*/
/*<JAV_SMARTSVN> PARAMETERS=-Xmx512m -Dsmartsvn.checkIncompatibleJava=false -jar "%app%"*/
/*<JAV_TTFEDIT> PARAMETERS=-Xms256m -Xmx256m -XX:+UseConcMarkSweepGC -XX:+UseParNewGC -XX:+CMSParallelRemarkEnabled -XX:SoftRefLRUPolicyMSPerMB=100000 -Xincgc -Dsun.java2d.d3d=True -Dsun.java2d.d3dtexbpp=16 -Dsun.java2d.ddscale=true -jar "%app%"*/
/*<CLA_MANIFEST> PARAMETERS=%cls% "%**P\%**F";ASSOCFILTER=*.jar;MINIMIZED=NO;NOAUTOCLOSE=YES*/
/*<JAR_MINESWEEPER4JAVA> PARAMETERS=-Duser.home=%app_path% -jar "%app%"*/
/*<JAR_GRADLE> PARAMETERS=%GRADLE_OPTS% -Dorg.gradle.appname=%cls% -classpath %classpath% org.gradle.launcher.GradleMain %1;SET PATH=%PATH%;%j_path%\bin;%j_path%\lib;%app_path%;SET CLASSPATH=%app_path%\%cls%-launcher.jar;%CLASSPATH%*/

/* Configurations provided by Joop Nijenhuis, http://joopn.home.xs4all.nl/os2ecs */
/*<JAV_SIMULATOR> PARAMETERS=-jar ".\bin\%cls%.jar"*/
/*<JAV_MEMORANDA> PARAMETERS=net.sf.memoranda.Start %1;SET CLASSPATH=memoranda.jar;./lib/xom-1.0.jar;./lib/xercesImpl.jar;./lib/xmlParserAPIs.jar;./lib/nekohtml.jar;./lib/nekohtmlXni.jar;./lib/kunststoff.jar;./lib/systray4j.jar*/
/*<JAV_BASEX> SET CLASSPATH=BaseX.jar*/
/*<JAV_DIYLC> PARAMETERS=_3570 -splash:splash.png -Xms512m -Xmx768m -Dorg.diylc.scriptRun=true -Dfile.encoding=UTF-8 -Dswing.defaultlaf=com.sun.java.swing.plaf.gtk.GTKLookAndFeel -jar "%cls%.jar";SET CLASSPATH=%app_path%_3570\lib*/
/*<JAV_CORE> PARAMETERS=-Xmx896m -jar "%cls%.jar"*/
/*<JAV_PM> PARAMETERS=-XX:+UseConcMarkSweepGC -Xms500M -Xmx800M -jar "%cls%.jar"*/
/*<CLA_EJE> PARAMETERS=com.cdsc.eje.gui.EJE;STARTUPDIR=%delete%( \COM\CDSC\EJE\GUI, %app_path% );SET CLASSPATH=.*/
/*<JAV_PIXELITOR> PARAMETERS=-Xmx128m -jar "%cls%.jar"*/
/*<JAV_JEKS> PARAMETERS=com.eteks.jeks.JeksFrame;SET CLASSPATH=jeks.jar*/
/*<JAV_TEXTTRIX> SET CLASSPATH=.\lib\jsyntaxpane.jar;.\lib\oster.jar;*/
/*<JAV_OBSERVATIONMANAGER> PARAMETERS=-Djava.ext.dirs=./lib de.lehmannet.om.ui.navigation.ObservationManager %1*/
/*<JAV_HTDP> PARAMETERS=-Xmx800m -jar "%cls%.jar"*/
/*<JAV_GREENFOOT> PARAMETERS=-Xms64m -Xmx256m bluej.Boot -greenfoot=true -bluej.compiler.showunchecked=false %1;SET CLASSPATH=%app_path%\lib\bluej.jar;%ojdk_path%\lib\tools.jar*/
/*<JAV_VASSAL> SET CLASSPATH=./lib/Vengine.jar*/
/*<JAV_ARTOFILLUSION> PARAMETERS=-Xmx128m -jar "%cls%.jar"*/
/*<JAV_JSYNOPTIC> PARAMETERS=-Xmx128m -jar "%cls%.jar"*/
/*<JAV_WEKA> PARAMETERS=-3-7-13 -jar "%cls%.jar"*/
/*<JAV_FSCAPE> SET CLASSPATH=%app_path%\lib\de.sciss.fscape-1.6.0.jar;*/
/*<JAV_JDRAW> PARAMETERS=-Dlf="javax.swing.plaf.metal.MetalLookAndFeel" -jar "%cls%.jar"*/
/*<JAV_UNSHAKE> PARAMETERS=-Xmx384m -jar "%cls%.jar"*/
/*<JAV_JTRON> PARAMETERS=-Xmx512m -Xms256m %1 -jar "%cls%.jar";SET CLASSPATH=jtron.jarjp.ac.nii.icpc2010.Main*/
/*<JAV_MAKAGIGA> PARAMETERS=-Xverify:none -Xms16m -Xmx128m -jar "%cls%.jar"*/
/*<JAV_PROJECTLIBRE> PARAMETERS=-180 -jar "%cls%.jar"*/
/*<JAV_SHARPTOOLS> PARAMETERS=SharpTools;SET CLASSPATH=SharpTools.jar;images.jar*/
/*<JAV_CSHEETS> PARAMETERS=-jar ".\lib\%cls%.jar"*/
/*<JAV_IMAGEEDITOR> PARAMETERS=-Xms512m -jar "%cls%.jar";SET CLASSPATH=I:\DTP\ImageEditor\lib*/
/*<JAV_XISS> PARAMETERS=-splash:rsrc/gui/images/about/bigLogo.png -jar "%cls%.jar"*/
/*<JAV_BINDINGS> PARAMETERS=-Xmx512M  lib\forms-1.0.5.jar;lib\jibx\jibx-run.jar;lib\jibx\xpp3.jar;lib\%cls%.jar freemind.main.FreeMindStarter;SET CLASSPATH=lib\freemind.jar;lib\commons-lang-2.0.jar;*/
/*<JAV_JALBUM> PARAMETERS=-Dbrowser.cmd="%programs%\firefox\firefox.exe" -Dbrowser.arg0="$url" -Xmx400M -jar "%cls%.jar"*/
/*<JAV_HODOKU> PARAMETERS=-Djava.io.tmpdir=%app_path%\temp -jar "%cls%.jar"*/
/*<JAV_FREECOL> PARAMETERS=-Xmx512M -jar "%cls%.jar"*/
/*<JAV_FREECOL> PARAMETERS=-Xmx512M -jar "%cls%.jar"*/
/*<JAV_TOTALVALIDATOR> PARAMETERS=\totalvalidatorbasic_v6131 -jar "%cls%.jar"*/
/*<JAV_BORG> PARAMETERS=-Xmx128m -XX:MinHeapFreeRatio=10 -XX:MaxHeapFreeRatio=20 -Xms24m -jar "%cls%.jar"*/
/*<JAV_NIFFLER3> PARAMETERS=-Xmx512M -jar "%cls%.jar"*/
/*<JAV_GEOGEBRA> PARAMETERS=-Xmx512m -jar "%cls%.jar"*/
/*<JAV_OPENPROJ> PARAMETERS=-Xms128m -Xmx512m -jar "%cls%.jar"*/
/*<JAV_DATACROW> PARAMETERS=-Xmx256m -jar "%cls%.jar"*/
/*<JAV_JABREF> PARAMETERS=-Xmx256m -jar "%cls%.jar"*/
/*<JAV_DRJAVA> PARAMETERS=-Xmx512m -Xms128m -jar "%cls%.jar"*/
/*<JAV_PDFSAM> PARAMETERS=-Xmx384m -jar "%cls%.jar"*/
/*<JAV_BLUEJ> PARAMETERS=-Dawt.useSystemAAFontSettings=on  bluej.Boot;SET CLASSPATH=%app_path%\lib\bluej.jar;%ojdk_path%\lib\tools.jar*/
/*<JAV_JAXE> PARAMETERS=-Duser.language=en -Xmx256m -jar "lib\%cls%.jar"*/
/*<JAV_WATERMARKER> PARAMETERS=-Xmx512m -jar "%cls%.jar"*/
/*<JAV_JSTOCK> PARAMETERS=-Xms64m -Xmx512m -jar "%cls%.jar"*/
/*<JAV_GOGUI> PARAMETERS=-jar ".\lib\%cls%.jar";SET CLASSPATH=%app_path%\lib*/
/*<JAV_JARNAL> PARAMETERS=-Dfile.encoding=UTF-8 -Xmx192m -jar "%cls%.jar"*/
/*<JAV_JPDFBOOKMARKS> PARAMETERS=-Xms64m -Xmx512m -jar "%cls%.jar"*/
/*<JAV_JIBS> PARAMETERS=-Xms64m -Xmx256m -jar "%cls%.jar"*/
/*<JAV_TWE> PARAMETERS=org.apache.tools.ant.Main -DSYSTEMROOT=%app_path%;SET CLASSPATH=%app_path%\lib\ant.jar;%app_path%\lib\ant-launcher.jar;%app_path%\lib\xercesImpl.jar*/
/*<JAV_GRIP> PARAMETERS=-Xms512m -Xmx768m net.grelf.grip.GRIP;SET CLASSPATH=[drive: GRIP]\Grip\GRIP.jar;[drive: GRIP]\Grip\jai_imageio.jar;[drive: GRIP]\Grip\clibwrapper_jiio.jar;*/
/*<JAV_TTFEDIT> PARAMETERS=-Xms256m -Xmx256m  -XX:+UseConcMarkSweepGC -XX:+UseParNewGC-XX:+CMSParallelRemarkEnabled -XX:SoftRefLRUPolicyMSPerMB=100000 -Xincgc -Dsun.java2d.d3d=True-Dsun.java2d.d3dtexbpp=16 -Dsun.java2d.translaccel=true -Dsun.java2d.ddscale=true -jar "%cls%.jar"*/
/*<JAV_GANTTPROJECT> PARAMETERS=-Xmx512m  -ea org.bardsoftware.eclipsito.Boot ganttproject-eclipsito-config.xml -log %1;SET CLASSPATH=%app_path%\eclipsito.jar;%app_path%*/
/*<CLA_PMD> PARAMETERS=537 net.sourceforge.pmd.PMD -d [drive: greenfoot]\Greenfoot\scenarios\lunarlander\Lander.java -rulesets java-basic,java-design;STARTUPDIR=%delete%( \NET\SOURCEFORGE\PMD, %app_path% );SET CLASSPATH=%app_path%537\lib\**/
/*<JAV_BRIC> PARAMETERS=-Xmx512m -jar "%cls%.jar"*/
/*<JAV_FX702P> PARAMETERS=Fx702p.jar;SET CLASSPATH=%app_path%\lib\javacc.jar-jar*/
/*<CLA_GEOMETRIA> SET CLASSPATH=%app_path%\lib\**/
/*<JAV_IJ> PARAMETERS=-Xmx512m -jar "%cls%.jar"*/
/*<JAV_JEDIT> PARAMETERS=-Xmx192M -jar "%cls%.jar"*/
/*<JAV_JPICEDT> PARAMETERS=-Xmx96m -jar "jpicedt\lib\%cls%.jar"*/
/*<JAV_STAMPPAGETOR> PARAMETERS=-Xmx512m -jar "%cls%.jar"*/
/*<JAV_JNPAD> PARAMETERS=-Xms64m -Xmx128m -jar "%cls%.jar"*/
/*<CLA_REGIM> PARAMETERS=-client -Xms64m -Xmx768m -Dit.tidalwave.imageio.raw.defaultSource=rawImageregim.Regim;STARTUPDIR=%delete%( \RAWIMAGEREGIM, %app_path% )*/
/*<JAV_RETYPAR> PARAMETERS=-Xmx512m -jar "%cls%.jar"*/
/*<JAV_IDIET> PARAMETERS=-Xmx128m -jar "%cls%.jar"*/
/*<JAV_SIET> PARAMETERS=-Xmx400m -jar "lib\%cls%.jar"*/
/*<JAV_LAUNCHER> PARAMETERS=-DUserMode=Single -jar ".\lib\%cls%.jar"*/
/*<JAV_JWORKSHEET> PARAMETERS=-Xmx180m -Xms32m -jar "%cls%.jar"*/
/*<JAV_JIGSAWPUZZLE> PARAMETERS=-Xmx640m -jar "%cls%.jar"*/
/*<JAV_JSOKO> PARAMETERS=-Xmx768m -jar "%cls%.jar"*/
