/*
 *      Author: Jan-Erik Lrka
 * Description: java code to read manifest in .jar file(s)
 *        Date: Sat 2 Jan, 2021
 *     Changes: -
 */

import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.jar.Attributes;
import java.util.jar.JarFile;
import java.util.jar.Manifest;

public class ManiFest {
    public static void main( String [] args ) {
        if( 0 < args.length && getOS() == "OS/2" ) {
            try {
                if( 0 < args.length ) {
                    boolean bAttr = ( 1 < args.length );
                    String filePath = args[0];
                    for( int i = 1; i + 1 < args.length; i++ )
                        filePath += ' ' + args[i];
                    if( 1 < args.length & args[ args.length - 1 ].endsWith( ".jar" ) ) {
                        filePath += ' ' + args[ args.length - 1 ];
                        bAttr = false;
                    }
                    File f = new File( filePath.replaceAll( "^\"|\"$", "" ) );
                    if( f.isFile() ) {
                        JarFile jf = new JarFile( f );
                        Manifest mf = jf.getManifest();
                        Attributes mas = mf.getMainAttributes();
                        if( mas != null ) {
                            if( bAttr ) {
                                System.out.println( args[ args.length - 1 ] + ": " + mas.getValue( args[ args.length - 1 ] ) );
                            } else {
                                for( Iterator it = mas.keySet().iterator(); it.hasNext(); ) {
                                    Attributes.Name attrName = (Attributes.Name) it.next();
                                    System.out.println( attrName + ": " + mas.getValue( attrName ) );
                                }
                            }
                        }
                        jf.close();
                    }
                }
            } catch( IOException ioe ) {}
        } else {
            System.err.println( "Usage:" );
            System.err.println( "      ManiFest file.jar" );
            System.err.println( "    or" );
            System.err.println( "      ManiFest file.jar Main-Class" );
        }
    }


    private static String getOS() {
        String [] sOSes = { "WIN", "MAC", "NUX", "NIX", "OS/2", "SUNOS" };
        String sOS = System.getProperty( "os.name" );
        for( int i = 0; i < sOSes.length; i++ )
            if( sOS.contains( sOSes[i] ) )
                return sOSes[i];
        return sOS;
    }
}