/*
 * Filename: harvest.cmd
 *   Author: JanErik
 *  Created: Fri Jan  8 2021
 *  Purpose: Script to harvest information from joop
 *  Changes:
 */
/* Load RexxUtil Library */
IF RxFuncQuery( 'SysLoadFuncs' ) THEN
DO
   CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
   CALL SysLoadFuncs
END

sze = 'D:\Home\Documents\joopn.home.xs4all.nl\os2ecs'
cfg = 'cfg.cfg'

CALL SysFileTree sze||'\*.htm', 'file.', 'FO'
CALL SysFileDelete cfg
DO i = 1 TO file.0
   CALL SysFileSearch '<PRE>', file.i, 'found.'
   CALL CHAROUT 'STDERR', '.'
   IF 0 < found.0 THEN
      CALL fetch file.i, cfg
END
CALL STREAM cfg, 'C', 'CLOSE'
RETURN 0

fetch: PROCEDURE
   crlf = D2C(13)||D2C(10)
   paths = '%programs% %home% %app_path%'
   subs = '\bin \lib \'
   f_size = STREAM( ARG(1), 'C', 'QUERY SIZE' )
   IF 10 < f_size THEN
   DO
      input = CHARIN( ARG(1), 1, f_size )
      CALL STREAM ARG(1), 'C', 'CLOSE'
      DO WHILE 0 < POS( '<PRE>', input )
         PARSE VALUE input WITH '<PRE>'mid'</PRE>'input
         DO WHILE 0 < POS( '<BR>', mid )
            PARSE VALUE mid WITH pre'<BR>'post
            mid = pre||post
         END
         PARSE VALUE mid WITH 'cd [drive:'tag']\'fldr(crlf)
         PARSE VALUE STRIP( fldr ) WITH fldr'\'
         tag = STRIP( tag )
         IF tag <> '' THEN
         DO
            DO WHILE 0 < POS( '[drive: java]\JAVA160ga5', mid )
               PARSE VALUE mid WITH pre'[drive: java]\JAVA160ga5'post
               mid = pre||'%ojdk_path%'||post
            END
            DO WHILE 0 < POS( '[drive: java]\JAVA160', mid )
               PARSE VALUE mid WITH pre'[drive: java]\JAVA160'post
               mid = pre||'%ojdk_path%'||post
            END
            DO WHILE 0 < POS( '[drive: programs]', mid )
               PARSE VALUE mid WITH pre'[drive: programs]'post
               mid = pre||'%programs%'||post
            END
            DO WHILE 0 < POS( 'C:\PROGRAMS', mid )
               PARSE VALUE mid WITH pre'C:\PROGRAMS'post
               mid = pre||'%programs%'||post
            END
            DO WHILE 0 < POS( 'C:\', mid )
               PARSE VALUE mid WITH pre'C:\'. post
               mid = pre||'%app_path% '||post
            END
            DO WHILE 0 < POS( '[drive: home]', mid )
               PARSE VALUE mid WITH pre'[drive: home]'post
               mid = pre||'%home%'||post
            END
            DO WHILE 0 < POS( '[drive: unixroot]', mid )
               PARSE VALUE mid WITH pre'[drive: unixroot]'post
               mid = pre||'%unixroot%'||post
            END
            DO WHILE 0 < POS( '[drive: '||tag||']\'||tag, mid )
               PARSE VALUE mid WITH pre'[drive: '(tag)']\'(tag)post
               mid = pre||'%app_path%'||post
            END
            DO WHILE 0 < POS( '[drive:'||tag||']\', mid )
               PARSE VALUE mid WITH pre'[drive:'(tag)']\'.'\'post
               mid = pre||'%app_path%\'||post
            END
            DO i = 1 TO WORDS( paths )
               DO j = 1 TO WORDS( subs )
                  sub = '-Duser.home='||SUBWORD( paths, i, 1 )||SUBWORD( subs, j, 1 )
                  PARSE VALUE mid WITH pre(sub)post
                  IF 0 < LENGTH( post ) THEN
                     mid = STRIP( pre||SUBWORD( post, 2 ) )
               END
            END
            PARSE VALUE mid WITH 'CLASSPATH='classpath(crlf)
            DO WHILE 0 < POS( crlf, mid )
               PARSE VALUE mid WITH pre(crlf)post
               mid = pre||post
            END
            IF 0 < POS( ' -classpath ', mid ) THEN
            DO
               PARSE VALUE mid WITH pre'-classpath 'classpath' 'post
               IF 0 < LENGTH( classpath ) THEN
                  mid = pre||post
            END
            ELSE IF 0 < POS( ' -CLASSPATH ', TRANSLATE( mid ) ) THEN
            DO
               PARSE VALUE mid WITH pre'-CLASSPATH 'classpath' 'post
               IF 0 < LENGTH( classpath ) THEN
                  mid = pre||post
            END
            ELSE IF 0 < POS( ' -cp ', mid ) THEN
            DO
               PARSE VALUE mid WITH pre'-cp 'classpath' 'post
               IF 0 < LENGTH( classpath ) THEN
                  mid = pre||post
            END
            ELSE IF 0 < POS( ' -CP ', TRANSLATE( mid ) ) THEN
            DO
               PARSE VALUE mid WITH pre'-CP 'classpath' 'post
               IF 0 < LENGTH( classpath ) THEN
                  mid = pre||post
            END
            classpath = STRIP( classpath )
            IF 0 < LENGTH( classpath ) THEN
               classpath = 'SET CLASSPATH='||classpath
            PARSE VALUE mid WITH 'java 'mid '-jar' jarfile . ' 2&gt;'
            PARSE VALUE mid WITH mid' 2&gt;'
            jarfile = STRIP( jarfile )
            PARSE VALUE REVERSE( jarfile ) WITH 'raj.'objid'\'jarpath .
            IF 0 < POS( '.jar', mid ) THEN
            DO
               IF 0 = LENGTH( objid ) THEN
               DO
                  PARSE VALUE mid WITH '-cp 'objid'.jar'
                  PARSE VALUE REVERSE( objid ) WITH objid'\'jarpath .
               END
               IF 0 = LENGTH( objid ) THEN
                  PARSE VALUE REVERSE( mid ) WITH 'raj.'objid'\'jarpath .
            END
            IF 0 = LENGTH( objid ) THEN
               objid = REVERSE( tag )
            IF 0 < POS( '/', objid ) THEN
               PARSE VALUE objid WITH objid'/'jarpath
            PARSE VALUE objid WITH objid'*'
            objid = STRIP( REVERSE( objid ) )
            PARSE VALUE objid WITH objid'-'
            PARSE VALUE objid WITH objid'_'
            PARSE VALUE objid WITH objid'%'
            PARSE VALUE objid WITH objid'.'
            objid = STRIP( objid )
            IF 0 < LENGTH( jarpath ) THEN
               jarpath = REVERSE( jarpath )||'\'
            IF 0 < LENGTH( objid ) THEN
            DO
               objar =  objid||'.jar'
               PARSE VALUE STRIP( mid ) WITH pre(objar)post
               IF 0 < LENGTH( post ) THEN
                  mid = pre||'%cls%.jar'||post
            END
               ELSE objid = tag
            objid = STRIP( TRANSLATE( objid ) )
            mid = STRIP( mid )
            IF 0 < POS( '-Duser.home=[drive: '||tag||']\'||fldr, mid ) THEN
               PARSE VALUE mid WITH pre'-Duser.home=[drive: '(tag)']\'(fldr)mid
            ELSE IF 0 < POS( '-Duser.home=[drive:'||tag||']\'||fldr, mid ) THEN
               PARSE VALUE mid WITH pre'-Duser.home=[drive:'(tag)']\'(fldr)mid
            ELSE IF IsBetween( 0, POS( '-Duser.home=[drive:', mid ), POS( tag, mid ) ) THEN
               PARSE VALUE mid WITH pre'-Duser.home=[drive: '(tag)']\'. mid
            ELSE IF 0 < POS( '-Duser.home=[drive:', mid ) THEN
               PARSE VALUE mid WITH pre'-Duser.home=[drive: '.']\'. mid
            ELSE IF 0 < POS( '-Duser.home=%app_path%', mid ) THEN
               PARSE VALUE mid WITH pre'-Duser.home=%app_path%' mid
            ELSE pre = ''
            mid = STRIP( pre||mid )
            IF 0 < LENGTH( mid ) | 0 < LENGTH( jarpath ) THEN
            DO
               IF 0 < LENGTH( classpath ) THEN
                  classpath = ';'||classpath
               IF 0 < LENGTH( STRIP( jarfile ) ) THEN
                  CALL LINEOUT ARG(2), '/*<JAV_'||objid||'> PARAMETERS='||STRIP( mid||' -jar "'||jarpath||'%cls%.jar"'||classpath||'*/' )
               ELSE IF 0 < POS( '.JAR', TRANSLATE( mid||classpath ) ) | 0 < POS( '-Djava.ext.dirs=', mid ) | 0 < POS( 'log4j', mid ) THEN
                  CALL LINEOUT ARG(2), '/*<JAV_'||objid||'> PARAMETERS='||STRIP( mid )||classpath||'*/'
               ELSE DO
                  cls = REVERSE( '.'||objid )
                  PARSE UPPER VALUE REVERSE( mid ) WITH pre(cls)rest'='
                  IF LEFT( REVERSE( pre ), 1 ) = '.' THEN
                     rest = SUBWORD( pre, WORDS( pre ) )||rest
                  IF LENGTH( cls ) < LENGTH( STRIP( rest ) ) THEN
                  DO
                     PARSE VALUE rest WITH rest' '
                     mid = mid||';STARTUPDIR=%delete%( \'||TRANSLATE( REVERSE( rest ), '\', '.' )||', %app_path% )'
                  END
                  CALL LINEOUT ARG(2), '/*<CLA_'||objid||'> PARAMETERS='||STRIP( mid )||classpath||'*/'
               END
            END
            ELSE IF 0 < POS( '.JAR', TRANSLATE( classpath ) ) THEN
               CALL LINEOUT ARG(2), '/*<JAV_'||objid||'> '||classpath||'*/'
            ELSE IF 0 < LENGTH( classpath ) THEN
               CALL LINEOUT ARG(2), '/*<CLA_'||objid||'> '||classpath||'*/'
         END
      END
   END
RETURN 0

IsBetween: PROCEDURE
RETURN ARG(1) < ARG(2) & ARG(2) < ARG(3)